
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Load_Save &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Load_Save</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">Training</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">LSTM_with_norm</span> <span class="k">as</span> <span class="nn">wn</span>
<span class="kn">import</span> <span class="nn">LSTM_chemistry</span> <span class="k">as</span> <span class="nn">chem</span>
<span class="kn">import</span> <span class="nn">main</span>
<span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">main</span>


<div class="viewcode-block" id="Load_Save"><a class="viewcode-back" href="../sphinx/Report.html#Load_Save.Load_Save">[docs]</a><span class="k">def</span> <span class="nf">Load_Save</span><span class="p">(</span><span class="n">report_name</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="s1">&#39;cpu&#39;</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">analysis</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
              <span class="n">epoch</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">dataset_name</span><span class="o">=</span><span class="s1">&#39;NASA&#39;</span><span class="p">,</span> <span class="n">report_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">complete</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
              <span class="n">denormalize_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">base_capacity</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>

    <span class="sd">&quot;&quot;&quot;Function for loading a report&#39;s model and simulating its performance.</span>

<span class="sd">    The function reaches into the report directory and loads both the best and</span>
<span class="sd">    last epochs&#39; models. It also reads which batteries were used for training</span>
<span class="sd">    and which were ignored (through the *load_info.txt* file).</span>
<span class="sd">    It will then evaluate the model in each battery that hasn&#39;t been</span>
<span class="sd">    ignored and save an image of each result in folders *Images_Best* (for the</span>
<span class="sd">    best epoch) and *Images_Final* (for the last epoch) inside of the original</span>
<span class="sd">    report folder (``report_name``).</span>

<span class="sd">    This function is perfect for being called just after training, for creating</span>
<span class="sd">    the ``analysis`` file and plots.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    report_name : str</span>
<span class="sd">        The name of the report directory. It&#39;s usually a date.</span>
<span class="sd">    device : torch.device or str, default = &#39;cpu&#39;</span>
<span class="sd">        In which device the model and evaluation should be done.</span>
<span class="sd">        Can either be &#39;cpu&#39; or a cuda (&#39;cuda:0&#39;, &#39;cuda:1&#39;, ...).</span>
<span class="sd">    plot_bool : bool, default = False</span>
<span class="sd">        A boolean variable indicating whether or not to plot the battery</span>
<span class="sd">        simulations as they are done.</span>
<span class="sd">    analysis : bool, default = True</span>
<span class="sd">        Whether or not to run a more individual analysis of the different</span>
<span class="sd">        batteries.</span>
<span class="sd">    epoch : int, optional</span>
<span class="sd">        The epoch number if the user wants to load the model&#39;s parameter for</span>
<span class="sd">        a specific epoch.</span>

<span class="sd">        .. note::</span>
<span class="sd">            This may not always be possible since the epoch&#39;s folder is usually</span>
<span class="sd">            deleted after training (see :func:`Training.Train`&#39;s and</span>
<span class="sd">            :func:`Report.Report`&#39;s ``remove_bool`` variable).</span>

<span class="sd">    dataset_name : {&#39;NASA&#39;, &#39;MIT&#39;, &#39;Tarascon Coin&#39;}</span>
<span class="sd">        A string explaining which dataset to use.</span>
<span class="sd">    report_bool : bool, default = True</span>
<span class="sd">        A boolean variable for controlling whether or not to create the images</span>
<span class="sd">        for each battery prediction.</span>
<span class="sd">    complete : bool, default = False</span>
<span class="sd">        Whether or not to run the analysis for all of the batteries in the</span>
<span class="sd">        dataset (regardless of whether or not they were used in training and</span>
<span class="sd">        validation).</span>

<span class="sd">    denormalize_bool : bool, default = True</span>
<span class="sd">        Whether or not we want the plot to show the de-normalized values or not,</span>
<span class="sd">        and whether or not to calculate the errors in function of the normalized</span>
<span class="sd">        or denormalized values.</span>

<span class="sd">        .. warning::</span>
<span class="sd">            Should be set to ``False`` for</span>
<span class="sd">            :std:doc:`LSTMs with norm &lt;LSTMwithNorm&gt;`, since the output</span>
<span class="sd">            denormalisation is already done inside the model. For others,</span>
<span class="sd">            ``True`` is the best option.</span>

<span class="sd">    base_capacity : float, optional</span>
<span class="sd">        The nominal capacity to be used in the :func:`~Load_Save.Analysis`</span>
<span class="sd">        function. This should be defined only when using dimensional capacity</span>
<span class="sd">        values for the model&#39;s output.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    NameError</span>
<span class="sd">        When an unknown ``dataset_name`` or ``model_name`` is given.</span>
<span class="sd">    AttributeError</span>
<span class="sd">        When the model does not have attribute ``model_name``.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1">#####</span>
    <span class="c1"># Opening the report:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports&#39;</span><span class="p">)</span>
    <span class="n">report_name</span> <span class="o">=</span> <span class="n">report_name</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">,</span> <span class="s1">&#39;:&#39;</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">report_name</span><span class="p">))</span>
    <span class="c1"># Opening the best model:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
    <span class="n">dir_name</span> <span class="o">=</span> <span class="s1">&#39;_Best&#39;</span>
    <span class="c1"># Opening training information:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;train_info_tuple_.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">train_tuple</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
    <span class="c1"># Opening validation information:</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;valid_info_tuple_.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
        <span class="n">valid_tuple</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
    <span class="c1"># Leaving the report folder:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>
    <span class="c1">#####</span>

    <span class="c1"># Defining the dataset function based on the model variant:</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;chemistry&#39;</span> <span class="ow">or</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;tech&#39;</span><span class="p">:</span>
            <span class="n">dataset_fn</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span>
        <span class="k">elif</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span>
            <span class="n">dataset_fn</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span>
        <span class="k">elif</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;with norm&#39;</span><span class="p">:</span>
            <span class="n">dataset_fn</span> <span class="o">=</span> <span class="n">wn</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span>
                <span class="s2">&quot;Model variant not yet supported: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">Model</span><span class="o">.</span><span class="n">model_name</span><span class="p">)</span>
            <span class="p">)</span>
    <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">AttributeError</span><span class="p">(</span>
            <span class="s2">&quot;Model does not have ``variant`` attribute,  call this function&quot;</span>
            <span class="s2">&quot; from Old_Load_Save.py instead&quot;</span>
        <span class="p">)</span>

    <span class="c1"># Getting information from the tuples:</span>
    <span class="n">train</span> <span class="o">=</span> <span class="n">train_tuple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">time_step</span> <span class="o">=</span> <span class="n">train_tuple</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">fixed_len</span> <span class="o">=</span> <span class="n">train_tuple</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span>
    <span class="n">norm</span> <span class="o">=</span> <span class="n">train_tuple</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span>

    <span class="k">if</span> <span class="n">complete</span><span class="p">:</span>
        <span class="c1"># All batteries in the dataset:</span>
        <span class="n">complete_battery_list</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;B&quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span> <span class="o">+</span> <span class="s2">&quot;.txt&quot;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span>
                                 <span class="nb">range</span><span class="p">(</span><span class="mi">100</span><span class="p">)]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="c1"># Only batteries used in training and validation:</span>
        <span class="n">complete_battery_list</span> <span class="o">=</span> <span class="n">train_tuple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">valid_tuple</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>

    <span class="c1">#####</span>
    <span class="c1"># Entering the dataset folder:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">main</span><span class="o">.</span><span class="n">path_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>

    <span class="c1"># Sorting battery names:</span>
    <span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>  <span class="c1"># All files in the folder</span>
    <span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>  <span class="c1"># List with the valid files</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
        <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>  <span class="c1"># Only take into acount</span>
        <span class="c1"># the battery files</span>
        <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

    <span class="n">loader_list</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="c1"># Creating the loader object for each battery:</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">complete_battery_list</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

        <span class="n">Battery_list</span> <span class="o">=</span> <span class="p">[</span><span class="n">Battery</span><span class="p">]</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">th_B</span> <span class="o">=</span> <span class="n">dataset_fn</span><span class="p">(</span>
                <span class="n">Battery_list</span><span class="p">,</span> <span class="n">Model</span><span class="o">.</span><span class="n">delta</span><span class="p">,</span> <span class="n">Model</span><span class="o">.</span><span class="n">version</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">norm</span><span class="p">,</span>
                <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span>
            <span class="p">)</span>
        <span class="k">except</span> <span class="ne">RuntimeError</span><span class="p">:</span>  <span class="c1"># Empty list of tensors</span>
            <span class="k">continue</span>

        <span class="n">B_ld</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">th_B</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">th_B</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                          <span class="n">num_workers</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">loader_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">B_ld</span><span class="p">)</span>

    <span class="c1"># Leaving the dataset folder:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
    <span class="c1"># Reentering the report folder:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span> <span class="o">+</span> <span class="n">report_name</span><span class="p">)</span>

    <span class="c1"># Looping twice, for the last and best epochs.</span>
    <span class="k">for</span> <span class="n">times</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">2</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">times</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="k">pass</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">epoch</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
                <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;base_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                    <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
                <span class="n">dir_name</span> <span class="o">=</span> <span class="s1">&#39;_Final&#39;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Epochs&#39;</span><span class="p">)</span>
                <span class="n">Model</span><span class="o">.</span><span class="n">load_state_dict</span><span class="p">(</span>
                    <span class="n">th</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s1">&#39;Epoch_&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">epoch</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span><span class="p">,</span> <span class="n">map_location</span><span class="o">=</span><span class="s1">&#39;cpu&#39;</span><span class="p">)</span>
                <span class="p">)</span>
                <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../&#39;</span><span class="p">)</span>
                <span class="n">dir_name</span> <span class="o">=</span> <span class="s1">&#39;_Epoch_&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">epoch</span><span class="p">)</span>

        <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>

        <span class="k">for</span> <span class="n">loader</span> <span class="ow">in</span> <span class="n">loader_list</span><span class="p">:</span>

            <span class="c1"># Battery&#39;s file name</span>
            <span class="n">file_name</span> <span class="o">=</span> <span class="n">loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">batteries</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>

            <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
                <span class="n">title</span> <span class="o">=</span> <span class="n">file_name</span> <span class="o">+</span> <span class="s1">&#39; (used in training)&#39;</span>
                <span class="nb">print</span><span class="p">(</span><span class="n">title</span><span class="p">)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">title</span> <span class="o">=</span> <span class="n">file_name</span>
                <span class="nb">print</span><span class="p">(</span><span class="n">title</span><span class="p">)</span>

            <span class="n">simulate</span><span class="p">(</span>
                <span class="n">loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="n">title</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="n">report_bool</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                <span class="n">file_name</span><span class="o">=</span><span class="n">file_name</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;.&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">],</span> <span class="n">plot_bool</span><span class="o">=</span><span class="n">plot_bool</span><span class="p">,</span>
                <span class="n">dir_name</span><span class="o">=</span><span class="n">dir_name</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="n">denormalize_bool</span>
            <span class="p">)</span>

        <span class="k">if</span> <span class="n">analysis</span><span class="p">:</span>
            <span class="n">Analysis</span><span class="p">(</span>
                <span class="n">loader_list</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">train</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">file_name</span><span class="o">=</span><span class="n">dir_name</span><span class="p">,</span>
                <span class="n">base_capacity</span><span class="o">=</span><span class="n">base_capacity</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="n">denormalize_bool</span>
            <span class="p">)</span>

    <span class="c1"># Leaving the folder</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span></div>


<div class="viewcode-block" id="Load_Save_v2"><a class="viewcode-back" href="../sphinx/Report.html#Load_Save.Load_Save_v2">[docs]</a><span class="k">def</span> <span class="nf">Load_Save_v2</span><span class="p">(</span><span class="n">report_name</span><span class="p">,</span> <span class="n">dataset_name</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="n">analysis</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="s1">&#39;cpu&#39;</span><span class="p">,</span> <span class="n">norm_test</span><span class="o">=</span><span class="s1">&#39;dataset&#39;</span><span class="p">,</span> <span class="n">Model</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span>
                 <span class="n">offset_analysis</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="mf">1e6</span><span class="p">,</span> <span class="n">denormalize_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                 <span class="n">base_capacity</span><span class="o">=</span><span class="mi">1</span><span class="p">):</span>

    <span class="sd">&quot;&quot;&quot;Function for running analysing a model on different datasets.</span>

<span class="sd">    The function takes a ``report_name`` as input, and accesses the report to</span>
<span class="sd">    find the desired model. With ``dataset_name``, it access the correct folder</span>
<span class="sd">    for the dataset to test.</span>

<span class="sd">    This function is different from :func:`~Load_Save.Load_Save` because it can</span>
<span class="sd">    apply a model to datasets different from the one it was trained on. The user</span>
<span class="sd">    can also choose how the standardisation parameters will be calculated for</span>
<span class="sd">    this dataset through the ``norm_test`` variable , although this won&#39;t change</span>
<span class="sd">    much for :std:doc:`LSTMs with normalisation &lt;LSTMwithNorm&gt;`, since in their</span>
<span class="sd">    case the normalisation is done inside of the model and its parameters won&#39;t</span>
<span class="sd">    be affected.</span>

<span class="sd">    .. note::</span>
<span class="sd">        How to proceed when a ``ModuleNotFoundError`` is raised:</span>
<span class="sd">        This is caused when a model trained with an older module tries to be</span>
<span class="sd">        loaded. The older and newer models are compatible (the only thing that</span>
<span class="sd">        changed between modules was only the ``Torch_Dataset_LSTM`` function).</span>

<span class="sd">        In order to make this work, you&#39;ll have to open the `TEST_Report.txt`</span>
<span class="sd">        file in the desired report folder. It will contain all of the</span>
<span class="sd">        information needed to initialize a similar model the parameters of which</span>
<span class="sd">        can be replaced with the ones saved in the report.</span>

<span class="sd">        In the `TEST_Report.txt` file, you&#39;ll find something like this:</span>

<span class="sd">        .. code-block:: text</span>

<span class="sd">            MODEL</span>
<span class="sd">              Model name: LSTM</span>
<span class="sd">              Version: 4</span>
<span class="sd">              Dataset Format: You et al. [56]</span>
<span class="sd">              Delta: 10</span>
<span class="sd">              Hidden layer dimension: 50</span>
<span class="sd">              Pooling_layer: bi_mean</span>
<span class="sd">              Dropout prob.: 0</span>
<span class="sd">              Number of linear layers: 1</span>

<span class="sd">        Define a model of the same version:</span>

<span class="sd">        .. code-block::</span>

<span class="sd">            model = LSTM_v4(Delta, Hidden layer dimension,</span>
<span class="sd">                            pooling_layer=Pooling_layer, drop_out=Dropout prob.,</span>
<span class="sd">                            version=Version, lin_layers=Number of linear layers,</span>
<span class="sd">                            lin_dropout=0)</span>

<span class="sd">        (If ``lin_dropout &gt; 0``, an extra entry will be present in the report).</span>
<span class="sd">        For versions 1 through 3, call :class:`LSTM_v1` instead.</span>
<span class="sd">        Then, just call this function again with variable ``Model=model``</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    report_name : str</span>
<span class="sd">        The name of the report folder inside the &quot;Reports&quot; folder.</span>
<span class="sd">    dataset_name : {&#39;NASA&#39;, &#39;MIT&#39;, &#39;Tarascon Coin&#39;}</span>
<span class="sd">        The name of the dataset to test the model on.</span>
<span class="sd">    fixed_len : int, default = 150</span>
<span class="sd">        The final length of the resampled charge curve data (in number of</span>
<span class="sd">        points). See ``Torch_Dataset_LSTM`` in `LSTM.py` for more information.</span>

<span class="sd">    time_step : float, optional</span>
<span class="sd">        The desired time step for the resampling procedure.</span>
<span class="sd">        If ``None`` is given, than a time step will be automatically generated</span>
<span class="sd">        in function of the given ``norm_test`` variable.</span>

<span class="sd">    analysis : bool, default = True</span>
<span class="sd">        Whether or not to run a quantitative analysis of the dataset.</span>
<span class="sd">        See ``Analysis`` function in `Load_Save` for more information.</span>

<span class="sd">    device : torch.device or str, default = &#39;cpu&#39;</span>
<span class="sd">        In which device the model and evaluation should be done.</span>
<span class="sd">        Can either be &#39;cpu&#39; or a cuda (&#39;cuda:0&#39;, &#39;cuda:1&#39;, ...).</span>

<span class="sd">    norm_test : str or list(str)</span>
<span class="sd">        Informs how to calculate the normalization information to be used for</span>
<span class="sd">        the data. It can be:</span>

<span class="sd">            &quot;Model&quot; : the model normalization will be used</span>
<span class="sd">            &quot;dataset&quot; : the whole dataset will be used</span>
<span class="sd">            list(str) : the batteries in the list</span>

<span class="sd">                Example: [&#39;B0001&#39;, &#39;B0005&#39;, &#39;B0025&#39;]</span>
<span class="sd">                Batteries 1, 5 and 25 from the dataset will be used.</span>

<span class="sd">        If ``time_step`` is ``None``, then the time_step will also be calculated</span>
<span class="sd">        automatically for these batteries.</span>

<span class="sd">    Model : torch.nn.Module, optional</span>
<span class="sd">        A model to use as a base for loading the report&#39;s parameters. This is</span>
<span class="sd">        only necessary when trying to load a Model trained with an older module.</span>
<span class="sd">        Check this function&#39;s note for more information on how this should be</span>
<span class="sd">        initialized.</span>
<span class="sd">    offset_analysis : bool, optional</span>
<span class="sd">        Whether or not to add an offset to the model&#39;s bias term in order to</span>
<span class="sd">        decrease the offset error.</span>
<span class="sd">    cycle_lim : int, optional</span>
<span class="sd">        The greatest cycle number to take into account for the dataset creation.</span>
<span class="sd">        Default equals ``1e6`` meaning that no cycles will be ignored.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    NameError</span>
<span class="sd">        When an unknown ``dataset_name``, model name or ``norm_test`` is given.</span>
<span class="sd">    ModuleNotFoundError</span>
<span class="sd">        When an older module tries to be imported.</span>
<span class="sd">    AttributeError</span>
<span class="sd">        When the model does not have attribute ``variant``.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1"># Opening the report folder:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span> <span class="o">+</span> <span class="n">report_name</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">Model</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;best_model.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">Model</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="k">except</span> <span class="ne">ModuleNotFoundError</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">ModuleNotFoundError</span><span class="p">(</span><span class="s2">&quot;It seems that you&#39;ve tried loading a&quot;</span> <span class="o">+</span>
                                      <span class="s2">&quot; model trained with an old module. The versions are compatible, &quot;</span> <span class="o">+</span>
                                      <span class="s2">&quot;check this function&#39;s (Load_Save_v2) docstring on how to proceed&quot;</span> <span class="o">+</span>
                                      <span class="s2">&quot;to make this work.&quot;</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">state_dict</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="s1">&#39;best_model_dict.txt&#39;</span><span class="p">)</span>
        <span class="n">Model</span><span class="o">.</span><span class="n">load_state_dict</span><span class="p">(</span><span class="n">state_dict</span><span class="p">)</span>
    <span class="c1"># Leaving the report folder:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span>

    <span class="c1"># Picking the dataset function:</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;chemistry&#39;</span> <span class="ow">or</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;tech&#39;</span><span class="p">:</span>
            <span class="n">dataset_fn</span> <span class="o">=</span> <span class="n">chem</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span>
        <span class="k">elif</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;normal&#39;</span><span class="p">:</span>
            <span class="n">dataset_fn</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span>
        <span class="k">elif</span> <span class="n">Model</span><span class="o">.</span><span class="n">variant</span> <span class="o">==</span> <span class="s1">&#39;with norm&#39;</span><span class="p">:</span>
            <span class="n">dataset_fn</span> <span class="o">=</span> <span class="n">wn</span><span class="o">.</span><span class="n">Torch_Dataset_LSTM</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">dataset_fn</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span>
                <span class="s2">&quot;Model type not yet supported: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">Model</span><span class="o">.</span><span class="n">model_name</span><span class="p">))</span>
    <span class="k">except</span> <span class="ne">AttributeError</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">AttributeError</span><span class="p">(</span>
            <span class="s2">&quot;Model does not have ``variant`` attribute,  call this function&quot;</span>
            <span class="s2">&quot; from Old_Load_Save.py instead&quot;</span>
        <span class="p">)</span>

    <span class="n">Model</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>

    <span class="c1"># Entering the dataset folder:</span>
    <span class="n">dataset_dict</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">path_dict</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">dataset_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>

    <span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>  <span class="c1"># All files in the folder</span>
    <span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>  <span class="c1"># List with the valid files</span>

    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
        <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>  <span class="c1"># Only take into acount</span>
        <span class="c1"># the battery files</span>
        <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

    <span class="n">complete_list</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">100</span><span class="p">)]</span>

    <span class="k">if</span> <span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;NASA&#39;</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">battery</span> <span class="ow">in</span> <span class="n">main</span><span class="o">.</span><span class="n">ignore_dict</span><span class="p">[</span><span class="s1">&#39;NASA&#39;</span><span class="p">]:</span>
            <span class="n">complete_list</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">battery</span><span class="p">)</span>
        <span class="c1"># base_capacity = 2.1</span>
    <span class="k">elif</span> <span class="p">(</span><span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;MIT&#39;</span><span class="p">):</span>
        <span class="c1"># base_capacity = 1.1</span>
        <span class="k">pass</span>
    <span class="k">elif</span> <span class="n">dataset_name</span> <span class="o">==</span> <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">:</span>
        <span class="n">complete_list</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s1">&#39;B0007.txt&#39;</span><span class="p">)</span>
        <span class="n">complete_list</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s1">&#39;B0008.txt&#39;</span><span class="p">)</span>
        <span class="n">complete_list</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s1">&#39;B0019.txt&#39;</span><span class="p">)</span>
        <span class="n">complete_list</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="s1">&#39;B0023.txt&#39;</span><span class="p">)</span>
        <span class="c1"># base_capacity = 0.1284</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span><span class="s2">&quot;Unknown Dataset&quot;</span><span class="p">)</span>

    <span class="n">battery_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">complete_list</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
            <span class="n">battery_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

    <span class="n">DELTA</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">delta</span>
    <span class="n">LSTM_version</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">version</span>

    <span class="k">if</span> <span class="n">norm_test</span> <span class="o">==</span> <span class="s1">&#39;Model&#39;</span><span class="p">:</span>
        <span class="n">norm</span> <span class="o">=</span> <span class="n">Model</span><span class="o">.</span><span class="n">norm</span>
        <span class="k">assert</span> <span class="n">time_step</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">,</span> <span class="s2">&quot;Can&#39;t use time_step = None with &quot;</span> \
                                      <span class="s2">&quot;norm_test = &#39;Model&#39;.&quot;</span>
        <span class="n">train</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">elif</span> <span class="n">norm_test</span> <span class="o">==</span> <span class="s1">&#39;dataset&#39;</span> <span class="ow">or</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">norm_test</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>

        <span class="k">if</span> <span class="n">norm_test</span> <span class="o">==</span> <span class="s1">&#39;dataset&#39;</span><span class="p">:</span>
            <span class="n">ds</span> <span class="o">=</span> <span class="n">battery_list</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">ds</span> <span class="o">=</span> <span class="p">[</span><span class="n">battery</span> <span class="k">for</span> <span class="n">battery</span> <span class="ow">in</span> <span class="n">battery_list</span>
                  <span class="k">if</span> <span class="n">battery</span><span class="o">.</span><span class="n">Name</span> <span class="ow">in</span> <span class="n">norm_test</span><span class="p">]</span>

        <span class="n">train_dataset</span> <span class="o">=</span> <span class="n">dataset_fn</span><span class="p">(</span>
            <span class="n">ds</span><span class="p">,</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
            <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span>
        <span class="p">)</span>

        <span class="n">norm</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span>
        <span class="n">time_step</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">time_step</span>
        <span class="n">train</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">batteries</span>
        <span class="k">if</span> <span class="n">offset_analysis</span><span class="p">:</span>
            <span class="n">Model</span> <span class="o">=</span> <span class="n">offset_calculator</span><span class="p">(</span><span class="n">Model</span><span class="p">,</span> <span class="n">train_dataset</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">)</span>

    <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">norm_test</span><span class="p">,</span> <span class="nb">tuple</span><span class="p">):</span>
        <span class="n">norm</span> <span class="o">=</span> <span class="n">norm_test</span>
        <span class="n">train</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">NameError</span><span class="p">(</span><span class="s2">&quot;Unsupported ``norm_test``: &quot;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">norm_test</span><span class="p">))</span>

    <span class="c1"># print(norm)</span>

    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;.//Reports/&#39;</span> <span class="o">+</span> <span class="n">report_name</span><span class="p">)</span>
    <span class="n">loader_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">battery</span> <span class="ow">in</span> <span class="n">battery_list</span><span class="p">:</span>
        <span class="n">dataset</span> <span class="o">=</span> <span class="n">dataset_fn</span><span class="p">([</span><span class="n">battery</span><span class="p">],</span> <span class="n">DELTA</span><span class="p">,</span> <span class="n">LSTM_version</span><span class="p">,</span>
                             <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span>
                             <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">norm</span><span class="p">)</span>

        <span class="n">loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">dataset</span><span class="p">),</span>
                            <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
        <span class="n">loader_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">loader</span><span class="p">)</span>

        <span class="n">simulate</span><span class="p">(</span><span class="n">loader</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">title</span><span class="o">=</span><span class="n">battery</span><span class="o">.</span><span class="n">Name</span><span class="p">,</span> <span class="n">report</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">block</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                 <span class="n">file_name</span><span class="o">=</span><span class="n">battery</span><span class="o">.</span><span class="n">Name</span><span class="p">,</span> <span class="n">plot_bool</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">dir_name</span><span class="o">=</span><span class="n">dataset_name</span><span class="p">,</span>
                 <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="n">denormalize_bool</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">analysis</span><span class="p">:</span>
        <span class="n">Analysis</span><span class="p">(</span><span class="n">loader_list</span><span class="p">,</span> <span class="n">Model</span><span class="p">,</span> <span class="n">train</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="n">device</span><span class="p">,</span>
                 <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;_&#39;</span> <span class="o">+</span> <span class="n">dataset_name</span><span class="p">,</span> <span class="n">base_capacity</span><span class="o">=</span><span class="n">base_capacity</span><span class="p">,</span>
                 <span class="n">denormalize</span><span class="o">=</span><span class="n">denormalize_bool</span><span class="p">)</span>

    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../&#39;</span><span class="p">)</span></div>


<div class="viewcode-block" id="Analysis"><a class="viewcode-back" href="../sphinx/Report.html#Load_Save.Analysis">[docs]</a><span class="k">def</span> <span class="nf">Analysis</span><span class="p">(</span><span class="n">battery_loader_list</span><span class="p">,</span> <span class="n">model</span><span class="p">,</span> <span class="n">train</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="s1">&#39;cpu&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">,</span>
             <span class="n">base_capacity</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">denormalize</span><span class="o">=</span><span class="kc">True</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    Analyses the model&#39;s performance over the different batteries.</span>

<span class="sd">    Calculates the mean and maximum absolute error, mean and maximum relative</span>
<span class="sd">    error, and the root mean squared error (RMSE).</span>

<span class="sd">    A report will create a text file with the results.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    battery_loader_list : list[torch.utils.data.DataLoader]</span>
<span class="sd">        The battery&#39;s DataLoader loader.</span>
<span class="sd">    model : torch.nn.Module</span>
<span class="sd">        The model to use for the analysis.</span>
<span class="sd">    device : torch.device or str, default = &#39;cpu&#39;</span>
<span class="sd">        In which device the model and evaluation should be done.</span>
<span class="sd">        Can either be &#39;cpu&#39; or a cuda (&#39;cuda:0&#39;, &#39;cuda:1&#39;, ...).</span>
<span class="sd">    file_name : str</span>
<span class="sd">        A string to add to the Analysis file name. The final name will be</span>
<span class="sd">        &#39;Analysis&#39;+file_name+&#39;.txt&#39;.</span>
<span class="sd">    base_capacity : float, default = 1</span>
<span class="sd">        The battery&#39;s maximum capacity value (at its beginning of life).</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    NotImplementedError</span>
<span class="sd">        If the normalization type present in battery_loader.dataset.norm is not</span>
<span class="sd">        supported.</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">analysis_file</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;Analysis&#39;</span> <span class="o">+</span> <span class="n">file_name</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span>

    <span class="n">model</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>

    <span class="c1"># L1 Loss function:</span>
    <span class="n">loss_fn</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">L1Loss</span><span class="p">(</span><span class="n">reduction</span><span class="o">=</span><span class="s1">&#39;none&#39;</span><span class="p">)</span>
    <span class="n">los2_fn</span> <span class="o">=</span> <span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>

    <span class="c1"># &quot;Simulation&quot;</span>
    <span class="k">with</span> <span class="n">th</span><span class="o">.</span><span class="n">no_grad</span><span class="p">():</span>
        <span class="n">model</span><span class="o">.</span><span class="n">eval</span><span class="p">()</span>
        <span class="k">for</span> <span class="n">battery_loader</span> <span class="ow">in</span> <span class="n">battery_loader_list</span><span class="p">:</span>
            <span class="n">output_list</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="n">labels_list</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">data</span><span class="p">,</span> <span class="n">labels</span> <span class="ow">in</span> <span class="n">battery_loader</span><span class="p">:</span>
                <span class="n">data</span> <span class="o">=</span> <span class="n">data</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
                <span class="n">labels</span> <span class="o">=</span> <span class="n">labels</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
                <span class="n">output</span> <span class="o">=</span> <span class="n">model</span><span class="o">.</span><span class="n">forward</span><span class="p">(</span><span class="n">data</span><span class="p">)</span>

                <span class="c1"># The following lines are more general (any batch_size)</span>
                <span class="n">output_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">output</span><span class="p">)</span>
                <span class="n">labels_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">labels</span><span class="p">)</span>

            <span class="c1"># Turning them back to th.Tensors</span>
            <span class="n">output</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">stack</span><span class="p">(</span><span class="n">output_list</span><span class="p">)</span>
            <span class="n">labels</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">stack</span><span class="p">(</span><span class="n">labels_list</span><span class="p">)</span>

            <span class="c1"># Denormalization:</span>
            <span class="n">norm</span> <span class="o">=</span> <span class="n">battery_loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">norm</span>
            <span class="k">if</span> <span class="n">denormalize</span><span class="p">:</span>
                <span class="k">if</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;zscore&#39;</span><span class="p">:</span>
                    <span class="n">output</span> <span class="o">=</span> <span class="n">output</span> <span class="o">*</span> <span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span> <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
                    <span class="n">labels</span> <span class="o">=</span> <span class="n">labels</span> <span class="o">*</span> <span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span> <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
                <span class="k">elif</span> <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">==</span> <span class="s1">&#39;minmax&#39;</span><span class="p">:</span>
                    <span class="n">output</span> <span class="o">=</span> <span class="n">output</span> <span class="o">*</span> <span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">))</span>\
                             <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
                    <span class="n">labels</span> <span class="o">=</span> <span class="n">labels</span> <span class="o">*</span> <span class="p">(</span><span class="n">norm</span><span class="p">[</span><span class="mi">3</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span> <span class="o">-</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">))</span>\
                             <span class="o">+</span> <span class="n">norm</span><span class="p">[</span><span class="mi">2</span><span class="p">]</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span>
                        <span class="n">norm</span><span class="p">[</span><span class="mi">4</span><span class="p">]</span> <span class="o">+</span> <span class="s1">&#39; normalization type not supported&#39;</span>
                    <span class="p">)</span>

            <span class="c1"># Absolute error:</span>
            <span class="n">abs_loss</span> <span class="o">=</span> <span class="n">loss_fn</span><span class="p">(</span><span class="n">output</span><span class="p">,</span> <span class="n">labels</span><span class="p">)</span>
            <span class="n">mean_abs</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">abs_loss</span><span class="p">)</span>
            <span class="n">amax_abs</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">abs_loss</span><span class="p">)</span>

            <span class="c1"># Relative error</span>
            <span class="n">rel_loss</span> <span class="o">=</span> <span class="n">abs_loss</span> <span class="o">/</span> <span class="n">output</span>
            <span class="n">mean_rel</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">rel_loss</span><span class="p">)</span>
            <span class="n">amax_rel</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">rel_loss</span><span class="p">)</span>

            <span class="c1"># Relative to the initial capacity value</span>
            <span class="n">mean_init</span> <span class="o">=</span> <span class="n">mean_abs</span> <span class="o">/</span> <span class="n">base_capacity</span>
            <span class="n">amax_init</span> <span class="o">=</span> <span class="n">amax_abs</span> <span class="o">/</span> <span class="n">base_capacity</span>

            <span class="c1"># RMSE</span>
            <span class="n">RMSE</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">sqrt</span><span class="p">(</span><span class="n">los2_fn</span><span class="p">(</span><span class="n">output</span><span class="p">,</span> <span class="n">labels</span><span class="p">))</span>

            <span class="n">battery_name</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">battery_loader</span><span class="o">.</span><span class="n">dataset</span><span class="o">.</span><span class="n">batteries</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
            <span class="k">if</span> <span class="n">battery_name</span> <span class="ow">in</span> <span class="n">train</span><span class="p">:</span>
                <span class="n">battery_name</span> <span class="o">+=</span> <span class="s1">&#39; (training)&#39;</span>

            <span class="n">analysis_file</span><span class="o">.</span><span class="n">write</span><span class="p">(</span>
                <span class="sa">f</span><span class="s2">&quot;Battery </span><span class="si">{</span><span class="n">battery_name</span><span class="si">}</span><span class="se">\n\n</span><span class="s2">&quot;</span>
                <span class="sa">f</span><span class="s2">&quot;    Mean and Max Absolute Error: &quot;</span>
                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">mean_abs</span><span class="o">.</span><span class="n">item</span><span class="p">())[:</span><span class="mi">6</span><span class="p">]</span><span class="si">}</span><span class="s2">, &quot;</span>
                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">amax_abs</span><span class="o">.</span><span class="n">item</span><span class="p">())[:</span><span class="mi">6</span><span class="p">]</span><span class="si">}</span><span class="se">\n</span><span class="s2">&quot;</span>
                <span class="sa">f</span><span class="s2">&quot;    Mean and Max Relative Error: &quot;</span>
                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">mean_rel</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="o">*</span><span class="mi">100</span><span class="p">)[:</span><span class="mi">4</span><span class="p">]</span><span class="si">}</span><span class="s2">%, &quot;</span>
                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">amax_rel</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="o">*</span><span class="mi">100</span><span class="p">)[:</span><span class="mi">4</span><span class="p">]</span><span class="si">}</span><span class="s2">%</span><span class="se">\n</span><span class="s2">&quot;</span>
                <span class="sa">f</span><span class="s2">&quot;    Relative to the BoL capacity: &quot;</span>
                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">mean_init</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="o">*</span><span class="mi">100</span><span class="p">)[:</span><span class="mi">4</span><span class="p">]</span><span class="si">}</span><span class="s2">%, &quot;</span>
                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">amax_init</span><span class="o">.</span><span class="n">item</span><span class="p">()</span><span class="o">*</span><span class="mi">100</span><span class="p">)[:</span><span class="mi">4</span><span class="p">]</span><span class="si">}</span><span class="s2">%</span><span class="se">\n</span><span class="s2">&quot;</span>
                <span class="sa">f</span><span class="s2">&quot;    RMSE: &quot;</span>
                <span class="sa">f</span><span class="s2">&quot;</span><span class="si">{</span><span class="nb">str</span><span class="p">(</span><span class="n">RMSE</span><span class="o">.</span><span class="n">item</span><span class="p">())[:</span><span class="mi">6</span><span class="p">]</span><span class="si">}</span><span class="se">\n\n</span><span class="s2">&quot;</span>
            <span class="p">)</span>

    <span class="n">analysis_file</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div>


<div class="viewcode-block" id="offset_calculator"><a class="viewcode-back" href="../sphinx/Report.html#Load_Save.offset_calculator">[docs]</a><span class="k">def</span> <span class="nf">offset_calculator</span><span class="p">(</span><span class="n">Model</span><span class="p">,</span> <span class="n">dataset</span><span class="p">,</span> <span class="n">device</span><span class="o">=</span><span class="s1">&#39;cpu&#39;</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Calculates the mean offset between prediction and experimental values.</span>

<span class="sd">    This function will automatically update the model&#39;s bias parameter in order</span>
<span class="sd">    to decrease the offset.</span>

<span class="sd">    .. note::</span>
<span class="sd">        Hasn&#39;t been used in a long time.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    Model : torch.nn.Module</span>
<span class="sd">        The Model to be analyzed and updated.</span>
<span class="sd">    dataset : torch.utils.data.Dataset</span>
<span class="sd">        The dataset to get the offset from.</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    The model with updated bias parameter.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">loader</span> <span class="o">=</span> <span class="n">DataLoader</span><span class="p">(</span><span class="n">dataset</span><span class="o">=</span><span class="n">dataset</span><span class="p">,</span> <span class="n">batch_size</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">dataset</span><span class="p">),</span> <span class="n">shuffle</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">inputs</span><span class="p">,</span> <span class="n">labels</span> <span class="ow">in</span> <span class="n">loader</span><span class="p">:</span>
        <span class="n">inputs</span> <span class="o">=</span> <span class="n">inputs</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
        <span class="n">labels</span> <span class="o">=</span> <span class="n">labels</span><span class="o">.</span><span class="n">to</span><span class="p">(</span><span class="n">device</span><span class="p">)</span>
        <span class="n">output</span> <span class="o">=</span> <span class="n">Model</span><span class="p">(</span><span class="n">inputs</span><span class="p">)</span>
        <span class="n">bias_tensor</span> <span class="o">=</span> <span class="n">labels</span> <span class="o">-</span> <span class="n">output</span>

    <span class="n">bias_value</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">mean</span><span class="p">(</span><span class="n">bias_tensor</span><span class="p">,</span> <span class="n">dim</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
    <span class="k">with</span> <span class="n">th</span><span class="o">.</span><span class="n">no_grad</span><span class="p">():</span>

        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">Model</span><span class="o">.</span><span class="n">lin1</span><span class="p">,</span> <span class="n">nn</span><span class="o">.</span><span class="n">Sequential</span><span class="p">):</span>
            <span class="c1"># The model has more than 1 linear layer</span>
            <span class="n">Model</span><span class="o">.</span><span class="n">lin1</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span><span class="o">.</span><span class="n">bias</span> <span class="o">+=</span> <span class="n">bias_value</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">Model</span><span class="o">.</span><span class="n">lin1</span><span class="o">.</span><span class="n">bias</span> <span class="o">+=</span> <span class="n">bias_value</span>

    <span class="k">return</span> <span class="n">Model</span></div>

</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>